// ======================================================================== //
//	IMServerProtocol.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

@protocol IMServerProtocol
- (NSData *)getPublicKeyForClient:(in id)client;
- (BOOL)submitPublicKey:(in NSData *)key fromClient:(in id)client;
- (NSString *)getEncryptedSymmetricKeyForClient:(in id)client;

- (NSDictionary *)serviceInformation:(in id)client;
- (oneway void)postServiceInformationForClient:(in id)client;

- (oneway void)sendRequest:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)sendResponse:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)sendAction:(in NSDictionary *)dictionary fromClient:(in id)client;

- (oneway void)updateProfile:(in NSDictionary *)dictionary fromClient:(in id)client;

- (oneway void)setTemporaryStatus:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)setStatus:(in NSDictionary *)serializedStatus fromClient:(in id)client;

- (void)addStatus:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)updateStatus:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)moveStatus:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)removeStatus:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)setIdle:(in NSDictionary *)dictionary fromClient:(in id)client;

- (void)addAccount:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)moveAccount:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)deleteAccount:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)updateAccount:(in NSDictionary *)dictionary fromClient:(in id)client;

- (oneway void)getUserInfo:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)getUserAwayMessage:(in NSDictionary *)dictionary fromClient:(in id)client;

- (void)addObject:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)moveObject:(in NSDictionary *)dictionary fromClient:(in id)client;
- (void)deleteObject:(in NSDictionary *)dictionary fromClient:(in id)client;
- (oneway void)updateObject:(in NSDictionary *)dictionary fromClient:(in id)client;

- (void)setEncoding:(int)encoding fromClient:(id)from;

- (NSDictionary *)fullContactListForClient:(in id)client;
- (NSDictionary *)accountInformationForClient:(in id)client;
- (NSDictionary *)profileInformationForClient:(in id)client;
- (NSArray *)statusArrayForClient:(in id)client;
- (NSDictionary *)preferencesForClient:(in id)client;
- (NSDictionary *)statusInformationForClient:(in id)client;

- (void)injectPreferences:(in NSDictionary *)prefs fromClient:(in id)client;
- (BOOL)saveSettingsForClient:(in id)client;

- (BOOL)addClient:(in id)client;
- (BOOL)authorizeClient:(in id)client withAuthorization:(in NSDictionary *)authorizationDictionary;
- (void)removeClient:(in id)client fromClient:(in id)from;

- (void)runForClient:(in id)client;
- (void)terminateForClient:(in id)client;

- (oneway void)requestQueuedMessages:(in id)client;
- (int)numberOfQueuedMessagesForClient:(in id)client;
@end