// ======================================================================== //
//	ClientProtocol.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

@protocol ClientProtocol
- (void)postedError:(NSDictionary *)dictionary;
- (void)accountStatus:(NSDictionary *)dictionary;
- (void)contactStatus:(NSDictionary *)dictionary;
- (void)serviceInformation:(NSDictionary *)dictionary;
- (void)incomingRequest:(NSDictionary *)dictionary;
- (void)incomingResponse:(NSDictionary *)dictionary;
- (void)serverPublicKey:(NSData *)key;
- (void)incomingAction:(NSDictionary *)dictionary;
- (BOOL)keepAlive;

- (BOOL)wantsToBecomeMaster;
- (oneway void)youAreTheMaster;
- (oneway void)youGotShafted;
- (oneway void)nonMasterRequestedStatusChange:(NSDictionary *)newStatus;

- (void)updateObject:(NSDictionary *)dictionary;
- (void)deleteObject:(NSDictionary *)dictionary;
- (void)addObject:(NSDictionary *)dictionary;
- (void)moveObject:(NSDictionary *)dictionary;
- (void)setCurrentEncoding:(int)encoding;

- (void)reloadContactList;
- (void)reloadAccountInformation;
- (void)reloadAccountStatusInformation;
- (void)reloadStatusInformation;
- (void)reloadProfileInformation;
- (void)reloadPreferences;
@end