//
//  NSStringAdditions.h
//  Proteus
//
//  Created by Justin Wood on Sun Feb 08 2004.
//  Copyright (c) 2004 Defaultware. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface NSString(_encodings_)
+ (NSArray *)allAvailableEncodings;
+ (NSStringEncoding)numberFromLocalizedStringEncodingName:(NSString*)aName;
@end


@interface NSString(EncodingAdditions)
+ (NSString *)stringWithCString:(const char *)cString encoding:(NSStringEncoding)encoding;
- (const char *)cStringUsingEncoding:(NSStringEncoding)encoding;
@end

@interface NSString (ProteusStringAdditions)
- (NSString *)stringByRemovingSpaces;
- (NSString *)stringByReplacingNewlines;
- (NSString *)stringWithHTMLEncodeWhiteSpace;
@end
