// ======================================================================== //
//	Request.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

@class Contact;

#import <Foundation/Foundation.h>
#import "Defines.h"

@interface Request : NSObject <NSCoding, NSCopying>
{
	NSMutableDictionary *data;
}

+ (Request *)requestWithDictionary:(NSDictionary *)dictionary;
- (id)initWithDictionary:(NSDictionary *)dictionary;

- (NSDictionary *)dictionary;

- (id)valueForKey:(NSString *)key;
- (void)setValue:(id)value forKey:(NSString *)key;

- (int)identifier;
- (void)setIdentifier:(int)identifier;

- (NSArray *)files;
- (void)setFiles:(NSArray *)files;

- (NSArray *)contactArray;
- (void)setContactArray:(NSArray *)contacts;

- (NSCalendarDate *)date;
- (void)setDate:(NSCalendarDate *)date;

- (NSString *)url;
- (void) setUrl:(NSString *)newUrl;

- (RequestType)type;
- (void) setType:(RequestType)newType;

- (NSString *)rawContent;
- (void)setRawContent:(NSString *)raw;

- (NSString *)message;
- (void)setMessage:(NSString *)newMessage;

- (NSAttributedString *)attributedMessage;
- (void)setAttributedMessage:(NSAttributedString *)newMessage;

- (void)addToContact:(Contact *) to;
- (void)removeToContact:(int)index;
- (int)numContacts;
- (NSEnumerator *)contactEnumerator;
- (Contact *)contactAtIndex:(int)index;

- (void)setFrom:(Contact *) from;
- (Contact *)from;

// Don't Use These
- (void)setOutgoing:(BOOL)outgoing;
- (BOOL)outgoing;

@end
