// ======================================================================== //
//   ProteusCommunicationController.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Jean-Francois Roy,    []  []  []  []          //
//				                    []  []  []  []          //
//						    []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //
/*
 *  ProteusCommunicationController.h
 *  imservices
 *
 *  Created by Jean-Francois Roy on Sun Apr 11 2004.
 *  Copyright (c) 2004 MacStorm. All rights reserved.
 *
 */

#import <ProteusService/Defines.h>

@class ServiceInterface;
@class Contact;
@class Request;
@class ProteusAccount;
@class Action;

@protocol ProteusCommunicationController
- (oneway void)handleRequest:(Request *)request;
- (oneway void)handleAction:(Action *)action;
- (oneway void)handleResponse:(Action *)response;

- (oneway void)userAdded:(Contact *)user toGroup:(NSString *)to;
- (oneway void)userMoved:(Contact *)contact from:(NSString *)from to:(NSString *)to;
- (oneway void)userRemoved:(Contact *)user;
- (oneway void)userUpdated:(Contact *)user;

- (oneway void)setStatus:(ProteusStatus)status;
- (oneway void)setStatus:(ProteusStatus)status withMessage:(NSString *)message;

- (oneway void)getContactInfo:(Contact *)contact;
- (oneway void)getContactAwayMessage:(Contact *)contact;

- (oneway void)updateProfile;
- (oneway void)updateGroupName:(NSString *)old newName:(NSString *)new;
@end
