// ======================================================================== //
//  ProteusStatus.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

#import <Foundation/Foundation.h>


@interface ProteusStatusObject : NSObject <NSCoding, NSCopying> {
	NSString *_identifier;
	int _hash;
	
	NSString *_name;
	NSString *_message;
	NSString *_processedMessage;
	int _status;
	BOOL _playSounds;
	BOOL _smsActive;
	BOOL _autoreplyActive;
}

+ (ProteusStatusObject *)separator;

- (id)initWithIdentifier:(NSString *)string;
- (id)initWithDictionary:(NSDictionary *)dictionary;

- (NSDictionary *)dictionary;
- (void)replaceInternalDictionary:(NSDictionary *)dictionary;

- (BOOL)isSeparatorItem;

- (NSString *)identifier;

- (NSString *)name;
- (void)setName:(NSString *)name;

- (NSString *)message;
- (void)setMessage:(NSString *)message;

- (NSString *)processedMessage;
- (void)setProcessedMessage:(NSString *)message;

- (int)status;
- (void)setStatus:(int)status;

- (BOOL)smsActive;
- (void)setSMSActive:(BOOL)active;

- (BOOL)playSounds;
- (void)setPlaySounds:(BOOL)play;

- (BOOL)autoreplyActive;
- (void)setAutoreplyActive:(BOOL)active;

@end
