// ======================================================================== //
// GAIM Service Plugin for Proteus					    //
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Andrew Wellington     []  []  []  []          //
//              http://www.wiretapped.net/~proton/  []  []  []  []          //
//                                                  []          []          //
//                                                  [][][][][][][]          //
//              (c) 2002-2004 Justin Wood,          []    []    []          //
//              Alien Technology                        []  []              //
//              http://www.proteusx.com/		[]  []              //
//                                                                          //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
//                                                                          //
// ==Note================================================================== //
// On a more personal note, I have put countless hours of my time in to     //
// This and its' companion sources. You are more than welcome to make use   //
// of my source, but keep please my list of accreditations untouched at the //
// top of each source file, as well as adding me (Justin Wood) to the list. //
//                                                                          //
// I have used many other people's source code as a basis for the design    //
// and implementation of my work. I am sure that they would also appreciate //
// the proper credit.                                                       //
//                                                                          //
// I love to get email, please drop me a line, source additions, changes,   //
// even a hello note.                                                       //
//                          - Justin    proteus@indigofield.com             //
// ==Credits (In Alphabetical Order)======================================= //
//                                                                          //
// Adium (A free, open source unique AIM client for Mac OS X) - Adam Iser   //
//    Visit <http://homepage.mac.com/adamiser> for the newest Adium         //
//    and source                                                            //
//                                                                          //
// EveryBuddy (A multiservice IM app for Linux) - Torrey Searle             //
//    Visit <http://www.everybuddy.com/> for information about Every Buddy  //
//                                                                          //
// Fire (A multiservice Instant Messaging app for Mac OS X) - Eric Peyton   //
//    Visit <http://www.epicware.com/fire.html for information about Fire   //
//                                                                          //
// GAIM (A multiservice Instant Messaging application for Linux)            //
//    Visit <http://gaim.sourceforge.net/ for information about GAIM        //
//                                                                          //
// Icy Juice (A free, open source ICQ client for Mac OS X) - Mitz Pettel    //
//    Visit <http://www.mitzpettel.com/ for information about Icy Juice     //
//                                                                          //
// Each of these service packages contain libraries also covered under      //
// similar agreements, please read them through and pay each of them the    //
// respect deserved. Thanks.                                                //
// ======================================================================== //

#import <Foundation/Foundation.h>

#import <ProteusService/CommunicationController.h>
#import <ProteusService/Defines.h>

/* GAIM includes ================================================= */
#include "internal.h"

#include "connection.h"
#include "conversation.h"
#include "core.h"
#include "debug.h"
#include "ft.h"
#include "notify.h"
#include "plugin.h"
#include "pounce.h"
#include "prefs.h"
#include "privacy.h"
#include "proxy.h"
#include "request.h"
#include "roomlist.h"
#include "signals.h"
#include "sslconn.h"
#include "sound.h"
#include "util.h"


@class Action, Request, Contact, Service, ProteusAccount;


@interface NSObject (GaimProtocolController)
- (BOOL)initProtocol;
- (GaimAccount *)createProtocolAccountForUser:(NSString *)userName;

- (NSStringEncoding)preferedNicknameEncoding;

- (void)willConnectAccount:(GaimAccount *)account;
- (void)didStartConnectToAccount:(GaimAccount *)account onConnection:(GaimConnection *)gc;
- (void)connectedWithConnection:(GaimConnection *)gc;

- (BOOL)respectCustomEncoding;
- (BOOL)knownUnicodeBuddy:(GaimBuddy *)b onConnection:(GaimConnection *)gc;

- (ProteusStatus)statusForBuddy:(GaimBuddy *)buddy onConnection:(GaimConnection *)gc;
- (const char *)gaimFlagForStatus:(ProteusStatus)status;
- (NSString *)preprocessStatusMessage:(NSString *)message forStatus:(ProteusStatus)status;
- (BOOL)mustClearOldStatusMessage;
- (void)setAvailableMessage:(const char *)text onConnection:(GaimConnection *)gc;
- (void)didSetStatus:(ProteusStatus)status withMessage:(NSString *)string onConnection:(GaimConnection *)gc;

- (const char *)availableTextForBuddy:(GaimBuddy *)b onConnection:(GaimConnection *)gc;

- (const char *)awayTextForBuddy:(GaimBuddy *)b onConnection:(GaimConnection *)gc;

- (BOOL)hasUserInformation;
- (NSString *)userInformationForBuddy:(GaimBuddy *)b onConnection:(GaimConnection *)gc;
- (BOOL)isBuddyMobile:(GaimBuddy *)b onConnection:(GaimConnection *)gc;
- (NSString *)additionalBuddyInfo:(GaimBuddy *)b onConnection:(GaimConnection *)gc;
- (void)requestAdditionalInformationForBuddy:(GaimBuddy *)buddy onConnection:(GaimConnection *)gc;
- (BOOL)getUserInformationForOfflineContacts;

- (BOOL)setStatusMessage;
- (void)updateProfileWithContact:(Contact *)profile andAccount:(ProteusAccount *)paccount onConnection:(GaimConnection *)gc;

- (GaimXfer *)createTransferForConnection:(GaimConnection *)gc andIdentifier:(const char *)destsn;

- (BOOL)buddyAuthorized:(GaimBuddy *)b onConnection:(GaimConnection *)gc;

- (BOOL)ignoreDisconnectForAccount:(GaimAccount *)account;
- (BOOL)ignoreStatusSetForAccount:(GaimAccount *)account;

- (BOOL)handleError:(ErrorType)error forAccount:(GaimAccount *)account;
@end


@interface GaimCommunicationController : NSObject <CommunicationController>
{
    Service *_service;
    
	BOOL connected;
    
	NSString *myName;
    
	NSMutableDictionary *convs;
    NSMutableDictionary *xfers;
    
    id protoController;
    
    GaimAccount *account;
    GaimConnection *gc;
    
    ProteusStatus storedStatus;
    NSString *storedStatusMessage;
}

- (id)initWithService:(Service *)service;

- (void)timerCallback:(NSTimer *)timer;
- (void)keepAliveTimer:(NSTimer *)timer;
- (void)mainTimer:(NSTimer *)timer;

- (void)handleAction:(Action *)action;
- (void)handleResponse:(Action *)response;
- (int)handleRequest:(Request *)request;
- (BOOL)ignoreDisconnectForAccount:(GaimAccount *)account;
- (BOOL)handleError:(ErrorType)error forAccount:(GaimAccount *)account;

- (void)userUpdated:(Contact *)contact;
- (void)userMoved:(Contact *)contact from:(NSString *)from to:(NSString *)to;
- (void)userAdded:(Contact *)contact toGroup:(NSString *)to;
- (void)userRemoved:(Contact *)contact;

- (void)updateProfile;
- (void)updateBuddyIcon;

- (BOOL)isConnected;
- (void)setConnected;
- (void)shutdownServices;
- (int)loginForUser:(NSString *)userName password:(NSString *)password status:(int)status server:(NSString *)server port:(int)port;
- (void)setEncoding:(int)encoding;

- (void)setStatus:(ProteusStatus)status withMessage:(NSString *)message;

- (void)getContactInfo:(Contact *)contact;
- (void)getContactAwayMessage:(Contact *)contact;

- (void)updateGroupName:(NSString *)old newName:(NSString *)new;

- (GaimConnection *)gc;
- (GaimAccount *)account;
- (id)protoController;

- (NSMutableDictionary *)convs;
- (GaimConversation *)convForContact:(Contact *)contact;
- (NSMutableDictionary *)xfers;
- (void)setXfer:(GaimXfer *)xfer forFileName:(NSString *)filename;
- (GaimXfer *)xferForFile:(NSString *)filename;

- (const char *)systemPathWithString:(NSString *)path;
- (NSString *)stringWithSystemPath:(const char *)path;

@end
