// ======================================================================== //
//	Defines.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

#define DEFAULT_ENCODING		    NSNotFound

typedef enum _RequestType {
	Message = 1,
	URL,
	ContactTransfer,
	FileTransfer,
	AuthorizationRequest,
	AuthorizationConfirmation,
	UserAddedMessage,

	ContactNotification,
	CustomNotification,
	
	AwayMessage,
	Autoresponse,
	TypingNotification,
	AuthorizationBlock,
	
	ContactUpdate
} RequestType;

typedef enum _ErrorType {
	ErrorCustomText = 0,
	ErrorIncorrectPassword,
	ErrorAccountDisabled,
	ErrorAccountBlocked,
	ErrorElsewhereLoggedIn,
	ErrorHostNotFound,
	ErrorCouldNotConnect,
	ErrorBadConnection,
	ErrorTryAgain,
	ErrorDisconnected,
	ErrorUnknown,
	ErrorMessageNotSent,
	ErrorRate,
	ErrorDisplayNameFormatting,
	ErrorServerMaintenance,
	ErrorServiceUnavailable,
	ErrorClientRefused,
	ErrorTooLarge,
	ErrorInPrivacyList,
	ErrorTooEvil,
	ErrorUserNotAvailable,
	ErrorOutgoingFileTransferFailed
} ErrorType;

typedef enum _ProteusStatus {
	Online = 1,
	FreeForChat,
	Invisible,
	Idle, // Don't set this status
	Occupied,
	DoNotDisturb,
	Away,
	NotAvailable,
	NotInList,
	Offline
} ProteusStatus;

typedef enum _ServiceStatus {
	Disconnected = 0,
	LookingUp = 1,
	Connecting,
	LoggingIn,
	Connected,
	WaitingForReconnect = -1
} ServiceStatus;

typedef enum _ContactImageFormat {
    None = 0,
    TIFF,
    PNG,
    JPEG,
    GIF,
	BMP
} ContactImageFormat;

typedef enum _Visibility {
	Normal = 0,
	AlwaysVisible,
	AlwaysInvisible
} Visibility;