// ======================================================================== //
//	ServiceInterface.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

#import <Foundation/Foundation.h>
#import "Defines.h"

@class Request, Service, Contact, Action;

@interface ServiceInterface : NSObject {
	BOOL interfaceRunning;
    NSLock * lock;
}

- (void)noteContact:(Contact *)contact inGroup:(NSString *)groupName;
- (void)displayError:(ErrorType)code additionalText:(NSString *)error withRemedy:(NSString *)text forService:(Service *)service;
- (void)passRequest:(Request *)request;
- (void)passAction:(Action *)request;
- (void)passResponse:(Action *)request;

- (NSString *)awayMessageForContact:(Contact *)contact withTemplate:(NSString *)awayMessage;
- (void)searchUserFound:(Contact *)contact;
- (void)searchComplete:(Service *)service;
- (void)serviceConnected:(Service *)service;
- (void)serviceDisconnected:(Service *)service;
- (void)serviceError:(Service *)service;
- (void)serviceStatusUpdate:(Service *)service;
- (void)contactUpdate:(Contact *)contact;
- (void)removeContact:(Contact *)contact;

- (Contact *)createContact;
- (Request *)createRequest;
- (Action *)createAction;
- (id)createObjectOfClass:(Class)className;
@end
