// ======================================================================== //
//	Contact.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

@class Request;

#import <Foundation/Foundation.h>
#import "Defines.h"


@interface Contact : NSObject <NSCoding, NSCopying>
{
    NSMutableDictionary *data;
    NSMutableSet *accounts;
    NSMutableArray *messageQueue;
    id myOwner;
    id account; // Can be used for caching accounts
    BOOL uuid;
}

- (NSComparisonResult)compare:(Contact *)contact;
- (NSComparisonResult)compareNick:(Contact *)object;
- (NSComparisonResult)compareStatus:(Contact *)object;

- (void)setDontAdd:(BOOL)dontAdd;
- (BOOL)dontAdd;

- (void)generateUUID;
- (NSString *)uuid;
- (void)stripUUID;

// Note, these are used for service REFERENCE only, don't really mean anything
- (NSString *)groupName;
- (void)setGroupName:(NSString *)name;
// End

- (NSMutableSet *)ownerAccounts;
- (void)noteOwnerAccount:(int)unid;
- (void)removeOwnerAccount:(int)unid;

- (void)setIdle:(int)idle;
- (int)idle;

- (void)setOwner:(id)owner;
- (id)owner;

- (void)setIsDirty:(BOOL)dirty;

- (void)setFirstName:(NSString *)name;
- (NSString *)firstName;

- (void)setLastName:(NSString *)name;
- (NSString *)lastName;

- (void)setInitial:(NSString *)initials;
- (NSString *)initial;

- (void)setEmail:(NSString *)email;
- (NSString *)email;

- (void)setStatusMessage:(NSString *)message;
- (NSString *)statusMessage;

- (void)setAuthorization:(BOOL)needsAuthorization;
- (BOOL)authorization;

- (void)setIsChatRoom:(BOOL)room;
- (BOOL)isChatRoom;

- (void)setCity:(NSString *)city;
- (NSString *)city;

- (void)setCountryCode:(int)code;
- (int)countryCode;

- (void)setCountryState:(NSString *)state;
- (NSString *)countryState;

- (void)setNotes:(NSString *)notes;
- (NSString *)notes;

- (void)setBirthdate:(NSCalendarDate *)date;
- (NSCalendarDate *)birthdate;

- (void)setGender:(char)gender;
- (char)gender;

- (void)setHomePage:(NSString *)url;
- (NSString *)homePage;

- (void)setAbout:(NSString *)about;
- (NSString *)about;

- (void)setPhoneNumber:(NSString *)number;
- (NSString *)phoneNumber;

- (void)setAccountIdentifier:(int)unid;
- (int)accountIdentifier;

// Alias to nick right now
- (NSString *)name;
// FIXME: rename nick to name
- (NSString *)nick;
- (void)setNick:(NSString *) newName;

- (NSString *)password;
- (void)setPassword:(NSString *) newPassword;

- (NSString *)identifier;
- (void)setIdentifier:(NSString *)newIdentifier;

- (NSDictionary *)briefDictionary;
- (void)replaceInternalData:(NSDictionary *)dictionary;

- (NSObject *)idleTime;
- (void)setIdleTime:(NSObject *)date;

- (ProteusStatus)status;
- (void)setStatus:(ProteusStatus)newStatus;

- (BOOL)showAwayMessages;
- (void)setShowAwayMessages:(BOOL)show;

- (NSString *)currentIP;
- (void)setCurrentIP:(NSString *) newIP;

- (void)setIgnore:(BOOL)ignore;
- (BOOL)ignore;

- (Visibility)visibility;
- (void)setVisibility:(Visibility)visiblity;

- (void)queueRequest:(Request *)request;
- (Request *)dequeueRequest;
- (Request *)peekRequest;

- (int)numberOfUnhandledRequests;
- (BOOL)unhandledRequests;

- (NSDictionary *)dictionaryWithoutPictures;
- (NSDictionary *)dictionaryForSaving;
- (NSDictionary *)dictionary;
- (void)loadFromDictionary:(NSDictionary *)dictionary;
- (void)addEntriesFromDictionary:(NSDictionary *)dictionary;

- (void)resetToDefaults;

- (void)setCellNumber:(NSString *)number;
- (NSString *)cellNumber;

- (void)setFaxNumber:(NSString *)number;
- (NSString *)faxNumber;

- (void)setAddress:(NSString *)address;
- (NSString *)address;

- (void)setPostalCode:(NSString *)code;
- (NSString *)postalCode;

- (NSData *)imageData;
- (void)setImageData:(NSData *)imageData;
- (void)clearAllImages;

- (void)setHasNewInformation:(BOOL)newinfo;
- (BOOL)hasNewInformation;

@end
