// ======================================================================== //
//	ProteusAccount.h
// ======================================================================== //
//                                                  [][]      [][]          //
//      imservices                                []    []  []    []        //
//                                                      [][][]              //
//      Copyright:                                    []      []            //
//              (c) 2002-2004 Justin Wood,          []  []  []  []          //
//              Alien Technology                    []  []  []  []          //
//              http://www.proteusx.com/            []          []          //
//                                                  [][][][][][][]          //
//                                                  []    []    []          //
//                                                      []  []              //
//                                                      []  []              //
// ==License Agreement===================================================== //
// This program is free software; you can redistribute it and/or modify it  //
// under the terms of the GNU General Public License as published by the    //
// Free Software Foundation; either version 2 of the License, or (at your   //
// option) any later version.                                               //
//                                                                          //
// This program is distributed in the hope that it will be useful, but      //
// WITHOUT ANY WARRANTY; without even the implied warranty of               //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU        //
// General Public License for more details.                                 //
//                                                                          //
// You should have received a copy of the GNU General Public License along  //
// with this program; if not, write to the Free Software Foundation, Inc.,  //
// 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                //
// ======================================================================== //

#import <Foundation/Foundation.h>

typedef enum _ConnectTypes {
	NoProxy = 0,
	SOCKS = 1,
	HTTPS,
	SOCKS5
} ConnectTypes;

@interface ProteusAccount : NSObject <NSCoding, NSCopying>
{
	NSMutableDictionary *data;
	id userData1;
}

- (id)valueForKey:(NSString *)key;
- (void)setValueForKey:(id)value forKey:(NSString *)key;

- (void)setDisabled:(BOOL)disabled;
- (BOOL)disabled;

- (void)setProxyType:(ConnectTypes)type;
- (ConnectTypes)proxyType;
- (void)setProxyIsCustom:(BOOL)custom;
- (BOOL)proxyIsCustom;
- (void)setProxyHost:(NSString *)proxyHost;
- (NSString *)proxyHost;
- (void)setProxyPort:(int)port;
- (int)proxyPort;
- (void)setProxyUsername:(NSString *)username;
- (NSString *)proxyUsername;
- (void)setProxyPassword:(NSString *)password;
- (NSString *)proxyPassword;

- (void)setConnectDate:(NSDate *)date;
- (NSDate *)connectDate;

- (void)setGracefullyDisconnected:(BOOL)disconnected;
- (BOOL)gracefullyDisconnected;

- (NSDictionary *)dictionary;
- (void)loadFromDictionary:(NSDictionary *)dictionary;

- (int)unid;
- (NSString *)displayName;
- (NSString *)accountDescription;
- (NSString *)serviceIdentifier;
- (NSString *)username;
- (NSString *)password;
- (NSString *)server;
- (int)port;

- (NSDictionary *)settings;
- (void)setSettings:(NSDictionary *)settings;

- (void)setSavePassword:(BOOL)save;
- (BOOL)savePassword;

- (void)setIgnoreUnknownContacts:(BOOL)ignore;
- (BOOL)ignoreUnknownContacts;
- (void)setHistoryDisabled:(BOOL)disabled;
- (BOOL)historyDisabled;

- (void)setUNID:(int)unid;
- (void)setAccountDescription:(NSString *)description;
- (void)setDisplayName:(NSString *)displayName;
- (void)setServiceIdentifier:(NSString *)identifier;
- (void)setUsername:(NSString *)username;
- (void)setPassword:(NSString *)password;
- (void)setServer:(NSString *)server;
- (void)setPort:(int)port;
@end
